// -*-c++-*-

/***************************************************************************
                          rcccinreader.h  -  A basic class for reading from
			                     std::cin
                             -------------------
    begin                : 17-JULY-2001
    copyright            : (C) 2001 by Tom Howard.
    email                : thomashoward@email.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _RCC_CIN_READER_H_
#define _RCC_CIN_READER_H_

#include "rccmemory.h"
#include "rccstring.h"
#include "rcctransmitter.h"
#include "rccexception.h"
#include "rccstopwatch.h"

class RCC_CinReader
  : public RCC_Transmitter < RCC_Pointer < RCC_String > >
{
public:
  bool read ()
  {
    static int count = 0;
    static RCC_StopWatch timer;

    RCC_Pointer < RCC_String > str_p = new RCC_String;

    try
      {
	timer.unPause ();
      }
    catch (...)
      {
	timer.start ();
      }

    if ( getline ( std::cin, *str_p ) )
      {
	timer.pause ();
	if ( *str_p != "" )
	  {
	    
	    transmit ( str_p );
	    ++count;
	    return true;
	  }
	else
	  return false;
      }
    else
      {
	timer.stop ();
	transmit ( str_p );
	std::cout << "total (r) = " << timer.time () << std::endl;
	std::cout << "ave (r) = " << timer.time () / count << std::endl;

	throw RCC_Exception ( "No more data" );
      }
  }
};

#endif
