// -*-c++-*-

/***************************************************************************
                          rccthread.h  -  Interface and implementation of a
			                  basic threading class
                             -------------------
    begin                : 17-JULY-2001
    copyright            : (C) 2001 by Tom Howard.
    email                : thomashoward@email.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _RCC_THREAD_H_
#define _RCC_THREAD_H_

#include "config.h"
#ifdef HAVE_PTHREAD_H
#include <pthread.h>
#include <iostream>

void* __RCC_Thread_start ( void* );

class RCC_Thread
{
public:
  RCC_Thread () {}

  ~RCC_Thread ()
  {
    pthread_cancel ( thread_ );
  }

  void join ()
  {
    pthread_join ( thread_, NULL );
  }

  virtual void start () = 0;  
  // derived classes should implement start () as follows
  //	void start ()
  //	{
  //	  _start ( this );
  //	}

  virtual void* main () = 0;
private:
  pthread_t thread_;

protected:
  void _start ( RCC_Thread* t )
  {
    pthread_create ( &thread_, NULL, &__RCC_Thread_start, t );
  }

};

inline void* __RCC_Thread_start ( void* arg )
{
  RCC_Thread* t_p = (RCC_Thread*)arg;
  if ( t_p != NULL )
    {
      return t_p->main ();
    }
  else
    {
      return NULL;
    }
}

#endif // HAVE_PTHREAD_H

#endif
